/************************************

	MySQL Service: Used to access
	the games local MySQL DB

	Written by Martin "Alathon" Grnbaum,
	Copyright JustDoMusic I/S, anno 2008
************************************/

/*

ChangeLog, started 19/03/2008:

21/03/2008;
* Added the datum/FillVariables procedure. See the bottom of MySQL.dm

19/03/2008:
* Implemented ChangeLog

* Touched up formatting procedures in formatting.dm

* Changed mysql_table.UpdateQuery, mysql_table.SelectQuery and mysql_table.InsertQuery to use
  the formatting procedures in formatting.dm .

* Added support for auto-generating a mysql_table's variables list, using the following process:
	Set the variables list to null
	Set the variables_type to a typepath
	The variables list will be all variables belonging to a datum of that type, except those which return 0
	from IsException(variable_name). Variables which fail issaved() are also excluded, unless you comment
	out the EXCLUDE_TMP #define at the top of tables.dm

* Added DBQuery.Lock(), DBQuery.Unlock, mysql.LockQuery(DBQuery), mysql.UnlockQuery(DBQuery)
  to replace manually setting DBQuery.locked.

* Changed mysql.Heartbeat() to take into account DisconnectDBCon() failing due to locked queries.
  Locked queries now prevent Heartbeat() from closing down the /dbcon, indefinately. You can force
  a DBQuery to get destroyed despite its locked setting using the changed format of RemoveQuery()

* Changed mysql.RemoveQuery() to use the following syntax:
	mysql.RemoveQuery(DBQuery, force = 0)

	If force is 1, the Query will be removed even if it is locked.

* Added the _ignore_locks variable to /mysql datum. This will cause locked queries to be treated as if they weren't.
  This defaults to 0

*/